clear
close all

load('pathPerm.mat')%Matrice dell possibili combinazioni delle distanze 8*8*8=512
load('combo.mat') %Matrice dei possibili PIN data una combinazione di distanze
load('RTnoOutliersFingerOrd.mat')
load('SILK')

ReactionTimes = RTnoOutliersFingerOrd(:,1:2);
ReactionTimes(ReactionTimes(:,1)==0)=10; %il tasto 0 viene trasformato in 10

% s=tasto di partenza
% t=tasto di arrivo
% weights distanza tra s e t

s = [1	1	1	1	1	1	1	1	1	1	2	2	2	2	2	2	2	2	2	2	3	3	3	3	3	3	3	3	3	3	4	4	4	4	4	4	4	4	4	4	5	5	5	5	5	5	5	5	5	5	6	6	6	6	6	6	6	6	6	6	7	7	7	7	7	7	7	7	7	7	8	8	8	8	8	8	8	8	8	8	9	9	9	9	9	9	9	9	9	9	10	10	10	10	10	10	10	10	10	10];
t = [10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9	10	1	2	3	4	5	6	7	8	9];
weights = [sqrt(10)	0	1	2	1	sqrt(2)	sqrt(5)	2	sqrt(5)	sqrt(8)	3	1	0	1	sqrt(2)	1	sqrt(2)	sqrt(5)	2	sqrt(5)	sqrt(10)	2	1	0	sqrt(5)	sqrt(2)	1	sqrt(8)	sqrt(5)	2	sqrt(5)	1	sqrt(2)	sqrt(5)	0	1	2	1	sqrt(2)	sqrt(5)	2	sqrt(2)	1	sqrt(2)	1	0	1	sqrt(2)	1	sqrt(2)	sqrt(5)	sqrt(5)	sqrt(2)	1	2	1	0	sqrt(5)	sqrt(2)	1	sqrt(2)	2	sqrt(5)	sqrt(8)	1	sqrt(2)	sqrt(5)	0	1	2	1	sqrt(5)	2	sqrt(5)	sqrt(2)	1	sqrt(2)	1	0	1	sqrt(2)	sqrt(8)	sqrt(5)	2	sqrt(5)	sqrt(2)	1	2	1	0	0	sqrt(10)	3	sqrt(10)	sqrt(5)	2	sqrt(5)	sqrt(2)	1	sqrt(2)];
G = digraph(s,t, weights); %creo il grafo del PINPAD
G.Nodes.Name = {'1' '2' '3' '4' '5' '6' '7' '8' '9' '0'}';
d = distances(G); %matrice delle distanze tra tasti
dist= [0, 1, 2, 3, sqrt(2), sqrt(8), sqrt(5), sqrt(10)]; % 0 1 2 3 D1 D2 SD LD


ReactionTimes (:,3) = ones(length(ReactionTimes),1)*9999;
%attribuisco le distanze al campione
for ii=1:length(ReactionTimes)-1
    if (ReactionTimes(ii,1) ~= 9999 && ReactionTimes(ii+1,1) ~= 9999)
         ReactionTimes(ii+1,3) = d(ReactionTimes(ii,1),ReactionTimes(ii+1,1));
    end
end
ReactionTimesFinger = ReactionTimes(RTnoOutliersFingerOrd(:,3)==1,:); %1 index, 0 others
ReactionTimesOther = ReactionTimes(RTnoOutliersFingerOrd(:,3)==0,:);
%% TRAINING SET

%imposto il data set per trainare il modello
Training = ReactionTimes(1:25975,:); %to train the model with all the data

%% GUESS SET
%imposto il dataset di prova
 Guess = ReactionTimes(25976:end,:); %to perform the attack to all

%% START TRAINING
Zero = Training(Training(:,3)==0,2); %inter-key time a distanza 0
One = Training(Training(:,3)==1,2);
Two = Training(Training(:,3)==2,2);
Three = Training(Training(:,3)==3,2);
D1  = Training(Training(:,3)==sqrt(2),2);
D2  = Training(Training(:,3)==sqrt(8),2);
SD  = Training(Training(:,3)==sqrt(5),2);
LD  = Training(Training(:,3)==sqrt(10),2);


%creo il modello per ogni distanza
ZeroHFit = gammaFit(Zero);
OneHFit = gammaFit(One);
TwoHFit = gammaFit(Two);
ThreeHFit = gammaFit(Three);
D1HFit = gammaFit(D1);
D2HFit = gammaFit(D2);
SDHFit = gammaFit(SD);
LDHFit = gammaFit(LD);

hold off

xlabel('Interkey Time (ms)','FontSize',12)
ylabel('Frequency','FontSize',12)
legend ('FontSize',12)
legend boxoff
grid off
title('')

PINFit=zeros(length(Guess),10);
PINFit(:,1) = Guess(:,1);
counter=0;
for ii=2:length(Guess)

    if Guess(ii,3)~=9999
        counter= counter+1;
        if counter == 3
            PINFit(ii-2,2) = d(Guess(ii-3,1),Guess(ii-2,1)); %calcolo la distanza effettiva tra 2 tasti
            PINFit(ii-1,2) = d(Guess(ii-2,1),Guess(ii-1,1));
            PINFit(ii,2)= d(Guess(ii-1,1),Guess(ii,1));
        end
        %setto la probabilita' di ogni distanza in base al modello
        PINFit(ii,3)=getGammaPoint(ZeroHFit,Guess(ii,2));
        PINFit(ii,4)=getGammaPoint(OneHFit,Guess(ii,2));
        PINFit(ii,5)=getGammaPoint(TwoHFit,Guess(ii,2));
        PINFit(ii,6)=getGammaPoint(ThreeHFit,Guess(ii,2));
        PINFit(ii,7)=getGammaPoint(D1HFit,Guess(ii,2));
        PINFit(ii,8)=getGammaPoint(D2HFit,Guess(ii,2));
        PINFit(ii,9)=getGammaPoint(SDHFit,Guess(ii,2));
        PINFit(ii,10)=getGammaPoint(LDHFit,Guess(ii,2));
    else
        counter=0;
    end    
end

%% SELCT THE MODEL
PINFitMS=PINFit;
MStmp=PINFitMS;
mediaMS=mean(PINFitMS(:,3:10),2);
MStmp(:,3:10)= MStmp(:,3:10)./mediaMS;

PINFit=MStmp; %MSN Model (best fit)
%PINFit=PINFitMS; %MS Model

%% ATTACK with PINO (Personal Identification Number Observer)

% Base attack
 [attemptsPerPINMS, attMS]=callPINO(PINFit,Guess,pathPerm,combo);
 


%% PLOT
bruteforce=1:10000;

figure
hold on



h1=cdfplot(attemptsPerPINMS(:,1));
h2=cdfplot(bruteforce);
h3=cdfplot(SILK);

hold off
xlabel('Number of Guesses','FontSize',12)
ylabel('PINs Recovered','FontSize',12)
legend ('FontSize',12)
legend boxoff
grid off
title('')

if exist ('h1','var')
    set(h1(:,1),'LineWidth',2, 'DisplayName','Base Attack')
end
if exist ('h2','var')
    set(h2(:,1),'LineWidth',2, 'DisplayName','Random Guessing')
end
if exist ('h3','var')
    set(h3(:,1),'LineWidth',2, 'DisplayName','SILK-TV')
end
%% Functions
function [pd1] = gammaFit(Input)
    pd1 = fitdist(Input, 'gamma');
    x_values = 0:max(Input);
    y=pdf(pd1,x_values);
    hold on
    plot(x_values,y/sum(y),'LineWidth',2);
end

function ZeroGamma = getGammaPoint(ZeroHFit,x)
    a=ZeroHFit.a;
    b=ZeroHFit.b;
    ZeroGamma = (x.^(a-1) .* exp(-x/b) / (b^a * gamma(a))); 
end

function prob=setProb(pathPerm,probGuess1,probGuess2,probGuess3)
    prob=zeros(length(pathPerm),1);
    for ii=1:length(pathPerm)
        prob(ii)=probGuess1(pathPerm(ii,2))+probGuess2(pathPerm(ii,3))+probGuess3(pathPerm(ii,4));
    end
end

function [attemptsPerPIN,att]=callPINO(PINFit,Guess,pathPerm,combo)
    counter=0;
    counterAtt=1;
    attemptsPerPIN=zeros(length(PINFit)/5,1);
    maxAttemptsPerPIN=zeros(length(PINFit)/5,1);
    att=zeros(length(PINFit)/5,1);
    f = waitbar(0,'Please wait i am finding your PIN...');
    for ii=2:length(PINFit)
        if Guess(ii,3)~=9999
            counter= counter+1;
            counterGuess=0;
            if counter == 3
                PINS=PINFit(ii-3:ii,1);
                PINS(PINS==10)=0;
                RealPIN = str2double(strcat(num2str(PINS(counter-2,1)),num2str(PINS(counter-1,1)),num2str(PINS(counter,1)),num2str(PINS(counter+1,1))));
                %setto le probabilit di ogni possibile PIN dai modelli
                pathPerm(:,1)=setProb(pathPerm, PINFit(ii-2,3:10), PINFit(ii-1,3:10), PINFit(ii,3:10));
                %oridno i PIN in base alla probabilit
                pathPerm = sortrows(pathPerm,1,'descend'); 
                
               
                AllPIN=[];
                PIN=[];
                PINFound = false;
                ww=1;
                counterPathPerm=1;
                firstRound=true;
                while PINFound == false %ciclo finch non trovo il PIN
                    if firstRound==false && ~isempty(PIN) && RealPIN == PIN(ww)
                        counterGuess=counterGuess+1;
                        PINFound = true;
                        attemptsPerPIN(counterAtt,1)=find(AllPIN==RealPIN);
                        attemptsPerPIN(counterAtt,2)=RealPIN;
                        maxAttemptsPerPIN(counterAtt)=length(AllPIN);
                        waitbar(counterAtt/(length(PINFit)/5),f,'Please wait i am finding your PIN...');
                        att(counterAtt,1)=counterPathPerm; % quante volte viene richiamato PINO
                        counterAtt=counterAtt+1;
                    elseif (ww<length(PIN)) %aggiorno l'iteratore per selezionare il PIN successivo
                        counterGuess=counterGuess+1;
                        ww=ww+1;
                    else %se ho scorso tutti i PIN data una serie di distanze cerco i PIN della successiva
                        ww=1;
                        counterPathPerm=counterPathPerm+1;
                        PINNan=combo(pathPerm(counterPathPerm-1,5),:);
                        PIN=PINNan;
                        PIN(isnan(PIN))=[];
                         if ~isempty(AllPIN)
                            sx = size(AllPIN);
                            sy = size(PIN);
                            a = max(sx(1),sy(1));
                            z = [[AllPIN;ones(abs([a 0]-sx))*99999],[PIN;ones(abs([a,0]-sy))*99999]]; %aggiungo in coda i nuovi PIN
                            AllPIN=unique(z,'stable'); %prendo solo i PIN unici (che non ho gia' provato) 
                            AllPIN(AllPIN==99999)=[];
                        else
                            AllPIN=PIN;
                        end
                        firstRound=false;
                    end
                end
            end
        else
         counter=0;
        end
    end
    delete(f)
end

